define(["exports","./dom.js","./layoutmanager.js"],function(_exports,_dom,_layoutmanager){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0;var scopes=[];function getElementToAutoFocus(view,options){var element;return options&&!1===options.findAutoFocusElement||!(element=view.querySelector(".autofocus"))?function(parent,limit,excludeClass){for(var elems=(parent||getDefaultScope()).querySelectorAll(function(excludeClass){if(!excludeClass)return focusableQuery;for(var newQuerySelectors=[focusableQuerySelectors.length],i=0,length=focusableQuerySelectors.length;i<length;i++)newQuerySelectors[i]=focusableQuerySelectors[i]+":not(."+excludeClass+")";return newQuerySelectors.join(",")}(excludeClass)),focusableElements=[],i=0,length=elems.length;i<length;i++){var elem=elems[i];if(isCurrentlyFocusableInternal(elem)&&(focusableElements.push(elem),limit&&focusableElements.length>=limit))break}return focusableElements}(view,1,"noautofocus")[0]:element}function autoFocus(view,options){view=getElementToAutoFocus(view,options);return view&&focus(view,options),view}function focus(element,options){for(;element.classList.contains("focusable");){var autoFocusElement=getElementToAutoFocus(element,options);if(!autoFocusElement)break;element=autoFocusElement}focusInternal(element,options)}function focusInternal(element,options){try{var preventScroll=options?options.preventScroll:null;null==preventScroll&&_layoutmanager.default.tv&&(preventScroll=!0),element.focus({preventScroll:preventScroll})}catch(err){console.log("Error in focusManager.autoFocus: "+err)}}var focusableTagNames=["INPUT","TEXTAREA","SELECT","BUTTON","A"],focusableQuerySelectors=focusableTagNames.map(function(t){return t+':not([tabindex="-1"]):not(:disabled)'}),focusableQuery=(focusableQuerySelectors.push(".focusable"),focusableQuerySelectors.join(","));var focusableParentQuery=focusableTagNames.join(",")+",.focusable";function focusableParent(elem){return elem.closest(focusableParentQuery)||elem}function isCurrentlyFocusableInternal(elem){return null!==elem.offsetParent}function getDefaultScope(){return scopes[0]||document.body}var focusContainerQueries=[".focuscontainer,.focuscontainer-x,.focuscontainer-left",".focuscontainer,.focuscontainer-x,.focuscontainer-right",".focuscontainer,.focuscontainer-y",".focuscontainer,.focuscontainer-y,.focuscontainer-down"];function getFocusContainer(elem,direction){direction=focusContainerQueries[direction];return elem.closest(direction)||document.body}function getOffset(elem){return null===(elem=elem.getBoundingClientRect?elem.getBoundingClientRect():{top:0,left:0,width:0,height:0}).right&&((elem={top:elem.top,left:elem.left,width:elem.width,height:elem.height}).right=elem.left+elem.width,elem.bottom=elem.top+elem.height),elem}function getNearestElement(activeElement,activeElementRect,direction,focusableElements,focusableContainer){for(var nearestElement,rect=activeElementRect,point1x=parseFloat(rect.left)||0,point1y=parseFloat(rect.top)||0,point2x=parseFloat(point1x+rect.width-1)||point1x,point2y=parseFloat(point1y+rect.height-1)||point1y,minDistance=1/0,i=0,length=focusableElements.length;i<length;i++){var curr=focusableElements[i];if(curr!==activeElement&&curr!==focusableContainer){var elementRect=getOffset(curr),elementRectWidth=elementRect.width,elementRectHeight=elementRect.height,elementRectLeft=elementRect.left,elementRectTop=elementRect.top;if(elementRectWidth||elementRectHeight){switch(direction){case 0:if(elementRectLeft>=rect.left)continue;if(elementRect.right===rect.right)continue;break;case 1:if(elementRect.right<=rect.right)continue;if(elementRectLeft===rect.left)continue;break;case 2:if(elementRectTop>=rect.top)continue;if(elementRect.bottom>=rect.bottom)continue;break;case 3:if(elementRect.bottom<=rect.bottom)continue;if(elementRectTop<=rect.top)continue}var x2=elementRectLeft+elementRectWidth-1,y2=elementRectTop+elementRectHeight-1,distX=void 0,distY=void 0;switch(direction){case 0:var intersectY=intersects(point1y,point2y,elementRectTop,y2),distX=Math.abs(point1x-Math.min(point1x,x2)),distY=intersectY?0:1+Math.min(Math.abs(point1y-y2),Math.abs(point2y-elementRectTop));break;case 1:intersectY=intersects(point1y,point2y,elementRectTop,y2);distX=Math.abs(point2x-Math.max(point2x,elementRectLeft)),distY=intersectY?0:1+Math.min(Math.abs(point1y-y2),Math.abs(point2y-elementRectTop));break;case 2:var intersectX=intersects(point1x,point2x,elementRectLeft,x2);distY=Math.abs(point1y-Math.min(point1y,y2)),distX=intersectX?0:1+Math.min(Math.abs(point1x-x2),Math.abs(point2x-elementRectLeft));break;case 3:intersectX=intersects(point1x,point2x,elementRectLeft,x2);distY=Math.abs(point2y-Math.max(point2y,elementRectTop)),distX=intersectX?0:1+Math.min(Math.abs(point1x-x2),Math.abs(point2x-elementRectLeft))}elementRectWidth=Math.sqrt(distX*distX+distY*distY);elementRectWidth<minDistance&&(nearestElement=curr,minDistance=elementRectWidth)}}}return nearestElement}function nav(activeElement,direction){var focusableContainer,selectedIndex,activeElementRect,focusable,container=(activeElement=(activeElement=activeElement||document.activeElement)&&focusableParent(activeElement))?getFocusContainer(activeElement,direction):getDefaultScope();activeElement?(focusableContainer=activeElement.closest(".focusable"),(selectedIndex=container.classList.contains("focus-by-sequence")?(focusable=container.querySelectorAll(focusableQuery),selectedIndex=Array.prototype.indexOf.call(focusable,activeElement),selectedIndex=0===direction||2===direction?selectedIndex-1:selectedIndex+1,focusable[selectedIndex=Math.min(Math.max(0,selectedIndex),focusable.length-1)]):(selectedIndex=!1,container.classList.contains("focus-bysubcontainer")&&(selectedIndex=!0,focusable=function(activeElement,direction){if(!(activeElement=activeElement.closest(".focus-subcontainer")))return null;for(var prop=2===direction?"previousSibling":"nextSibling",siblingContainer=activeElement[prop];siblingContainer;){var elems=siblingContainer.querySelectorAll(focusableQuery);if(elems.length)return elems;siblingContainer=siblingContainer[prop]}return null}(activeElement,direction)),focusable=focusable||(container=selectedIndex?(selectedIndex=container.parentNode)?getFocusContainer(selectedIndex,direction):getDefaultScope():container).querySelectorAll(focusableQuery),getNearestElement(activeElement,activeElementRect=getOffset(activeElement),direction,focusable,focusableContainer)))&&(!activeElement||(focusable=selectedIndex.closest(".focusable"))&&focusable!==selectedIndex&&focusableContainer!==focusable&&(selectedIndex=focusable),"autofocus"!==(focusable=selectedIndex.getAttribute("data-focusabletype"))?"nearest"!==focusable?focusInternal(selectedIndex,{}):(focusable=getNearestElement(activeElement,activeElementRect=activeElementRect||getOffset(activeElement),direction,selectedIndex.querySelectorAll(focusableQuery),focusableContainer))?focusInternal(focusable):autoFocus(selectedIndex):autoFocus(selectedIndex))):autoFocus(container,{findAutoFocusElement:!1})}function intersectsInternal(a1,a2,b1,b2){return a1<=b1&&b1<=a2||a1<=b2&&b2<=a2}function intersects(a1,a2,b1,b2){return intersectsInternal(a1,a2,b1,b2)||intersectsInternal(b1,b2,a1,a2)}_exports.default={autoFocus:autoFocus,focus:focus,focusableParent:focusableParent,moveLeft:function(sourceElement){nav(sourceElement,0)},moveRight:function(sourceElement){nav(sourceElement,1)},moveUp:function(sourceElement){nav(sourceElement,2)},moveDown:function(sourceElement){nav(sourceElement,3)},sendText:function(text){document.activeElement.value=text},isCurrentlyFocusable:function(elem){return!!elem.matches(focusableQuery)&&null!==elem.offsetParent},pushScope:function(elem){scopes.push(elem)},popScope:function(elem){scopes.length&&--scopes.length},hasExclusiveFocusScope:function(){return scopes.length},getCurrentScope:getDefaultScope}});